import { SqliteParams, SqliteRow } from './sqlite.common';
export declare class SQLiteDatabase {
    filePath: string;
    db: FMDatabase;
    transformBlobs: boolean;
    constructor(filePath: string, options?: {
        threading?: boolean;
        transformBlobs?: boolean;
        readOnly?: boolean;
    });
    isOpen: boolean;
    open(): Promise<boolean>;
    close(): Promise<void>;
    setVersion(version: number): Promise<void>;
    getVersion(): Promise<number>;
    execute(query: string, params?: SqliteParams): Promise<void>;
    get(query: string, params?: SqliteParams, transformBlobs?: boolean): Promise<SqliteRow>;
    getArray(query: string, params?: SqliteParams, transformBlobs?: boolean): Promise<any[]>;
    select(query: string, params?: SqliteParams, transformBlobs?: boolean): Promise<SqliteRow[]>;
    each(query: string, params: SqliteParams, callback: (error: Error, result: SqliteRow) => void, complete: (error: Error, count: number) => void, transformBlobs?: boolean): Promise<number>;
    selectArray(query: string, params?: SqliteParams, transformBlobs?: boolean): Promise<any[][]>;
    _isInTransaction: boolean;
    transaction<T = any>(action: (cancel?: () => void) => Promise<T>): Promise<T>;
}
export declare function openOrCreate(filePath: string, flags?: number, options?: {
    readOnly?: boolean;
    transformBlobs?: boolean;
    threading?: boolean;
}): SQLiteDatabase;
export declare const deleteDatabase: (filePath: string) => boolean;
