import { SqliteParams, SqliteRow } from './sqlite.common';
export declare function byteArrayToBuffer(value: any): Uint8Array;
export declare class SQLiteDatabaseBase {
    filePath: string;
    db: android.database.sqlite.SQLiteDatabase;
    flags: any;
    transformBlobs: boolean;
    constructor(filePath: string, options?: {
        threading?: boolean;
        readOnly?: boolean;
        flags?: number;
        transformBlobs?: boolean;
    });
    _isInTransaction: boolean;
    threading: boolean;
    worker: Worker;
    onWorkerMessage(event: {
        data: {
            result?: any;
            error?: any;
            id?: number;
        };
    }): void;
    lastId: number;
    sendMessageToWorker(nativeData: any, messageData: any, timeout?: number): Promise<{
        id: number;
        nativeDatas?: {
            [k: string]: any;
        };
        [k: string]: any;
    }>;
    get isOpen(): boolean;
    close(): Promise<void>;
    setVersion(version: number): Promise<void>;
    getVersion(): Promise<number>;
    execute(query: string, params?: SqliteParams): Promise<void | {
        [k: string]: any;
        id: number;
        nativeDatas?: {
            [k: string]: any;
        };
    }>;
    get(query: string, params?: SqliteParams, transformBlobs?: boolean): Promise<SqliteRow>;
    getArray(query: string, params?: SqliteParams, transformBlobs?: boolean): Promise<any[] | {
        [k: string]: any;
        id: number;
        nativeDatas?: {
            [k: string]: any;
        };
    }>;
    select(query: string, params?: SqliteParams, transformBlobs?: boolean): Promise<SqliteRow[] | {
        [k: string]: any;
        id: number;
        nativeDatas?: {
            [k: string]: any;
        };
    }>;
    selectArray(query: string, params?: SqliteParams, transformBlobs?: boolean): Promise<any[][] | {
        [k: string]: any;
        id: number;
        nativeDatas?: {
            [k: string]: any;
        };
    }>;
    each(query: string, params: SqliteParams, callback: (error: Error, result: any) => void, complete: (error: Error, count: number) => void, transformBlobs?: boolean): Promise<number>;
    transaction<T = any>(action: (cancel?: () => void) => Promise<T>): Promise<T>;
}
