import { NativescriptDriver } from './NativescriptDriver';
let installed = false;
export function installMixins() {
    if (installed) {
        return;
    }
    installed = true;
    const DriverFactory = require('@nativescript-community/typeorm/browser/driver/DriverFactory').DriverFactory;
    const oldFunc = DriverFactory.prototype.create;
    DriverFactory.prototype.create = function (connection) {
        const { type } = connection.options;
        switch (type) {
            case 'nativescript':
            case '@akylas/nativescript-sqlite':
                return new NativescriptDriver(connection);
            default:
                return oldFunc.call(this, connection);
        }
    };
}
//# sourceMappingURL=index.js.map