const context = self;
import { SQLiteDatabaseBase } from './sqlitedatabase';
const fakeDatabase = new SQLiteDatabaseBase(null);
context.onmessage = (async (event) => {
    const data = event.data;
    switch (data.type) {
        case 'terminate':
            context.close();
            break;
        case 'call':
            const id = data.id;
            const call = data.callName;
            const args = data.args;
            const db = com.akylas.sqlite.WorkersContext.getValue(`${id}_db`);
            fakeDatabase.db = db;
            fakeDatabase.threading = false;
            if (data.dbOptions) {
                Object.assign(fakeDatabase, data.dbOptions);
            }
            try {
                const result = await fakeDatabase[call].apply(fakeDatabase, args);
                global.postMessage({
                    id,
                    result,
                });
            }
            catch (err) {
                global.postMessage(Object.assign(data, {
                    id,
                    error: err.toString(),
                }));
            }
            break;
    }
});
//# sourceMappingURL=worker.js.map