"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const platform_1 = require("../helpers/platform");
const virtualModules_1 = require("../helpers/virtualModules");
const index_1 = require("../index");
const base_1 = __importDefault(require("./base"));
function default_1(config, env = index_1.env) {
    base_1.default(config, env);
    const entryPath = platform_1.getEntryPath();
    const filterRE = '/.(xml|js|s?css)$/';
    const virtualEntryPath = virtualModules_1.addVirtualEntry(config, 'javascript', `
		// VIRTUAL ENTRY START
		require('@nativescript/core/bundle-entry-points')
		const context = require.context("~/", /* deep: */ true, /* filter: */ ${filterRE});
		global.registerWebpackModules(context);
		// VIRTUAL ENTRY END
	`);
    config.entry('bundle').add(virtualEntryPath);
    // config.resolve.extensions.add('.xml');
    // set up core HMR
    config.module
        .rule('hmr-core')
        .test(/\.js$/)
        .exclude.add(/node_modules/)
        .add(entryPath)
        .end()
        .use('nativescript-hot-loader')
        .loader('nativescript-hot-loader')
        .options({
        appPath: platform_1.getEntryDirPath(),
    });
    return config;
}
exports.default = default_1;
//# sourceMappingURL=javascript.js.map